package com.jscape.inet.ssh.protocol.v2.marshaling;

import com.jscape.inet.ssh.protocol.messages.Message;
import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.MpintCodec;
import com.jscape.inet.ssh.protocol.v2.messages.SshMsgKexDhInit;
import com.jscape.util.io.DataCodec;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.math.BigInteger;

/**
 * @author Alex Usun
 */
public class SshMsgKexDhInitCodec
        implements DataCodec<Message> {

    @Override
    public Message read(InputStream in)
            throws IOException {
        BigInteger e = MpintCodec.readValue(in);

        return new SshMsgKexDhInit(e);
    }

    @Override
    public void write(Message value, OutputStream out)
            throws IOException {
        SshMsgKexDhInit message = (SshMsgKexDhInit) value;
        MpintCodec.writeValue(message.e, out);
    }
}
